import { TemplateStatement } from './parser/statements';
declare class Bigodon {
    private readonly helpers;
    /** Parses a template and returns an AST representing it. This can be persisted as JSON for later usage. */
    parse: (template: string) => TemplateStatement;
    /** Runs an AST returned by the {@link Bigodon#parse} method. */
    run: (ast: TemplateStatement, context?: object) => Promise<string>;
    /** Compiles a template and returns a function that, when called, executes it */
    compile: (template: string) => (context?: object) => Promise<string>;
    addHelper: (name: string, helper: Function) => Bigodon;
}
/** Parses a template and returns an AST representing it. This can be persisted as JSON for later usage. */
export declare const parse: (template: string) => TemplateStatement;
/** Runs an AST returned by the {@link parse} method. */
export declare const run: (ast: TemplateStatement, context?: object) => Promise<string>;
/** Compiles a template and returns a function that, when called, executes it */
export declare const compile: (template: string) => (context?: object) => Promise<string>;
export { TemplateStatement } from './parser/statements';
export default Bigodon;
