export declare type TextStatement = {
    type: 'TEXT';
    value: string;
};
export declare type CommentStatement = {
    type: 'COMMENT';
    value: string;
};
export declare type ExpressionStatement = {
    type: 'EXPRESSION';
    path: string;
    params: (ExpressionStatement | LiteralStatement)[];
};
export declare type MustacheStatement = {
    type: 'MUSTACHE';
    expression: ExpressionStatement | LiteralStatement;
};
export declare type BlockStatement = {
    type: 'BLOCK';
    isNegated: boolean;
    expression: ExpressionStatement;
    statements: Statement[];
    elseStatements?: Statement[];
};
export declare type TemplateStatement = {
    type: 'TEMPLATE';
    version: number;
    statements: Statement[];
};
export declare type LiteralStatement = {
    type: 'LITERAL';
    value: string | number | boolean | null | undefined;
};
export declare type Statement = TextStatement | LiteralStatement | CommentStatement | BlockStatement | ExpressionStatement | MustacheStatement | TemplateStatement;
